/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "language.h"

void languageInit(language_t *language) {
  language->stringCount = 0;
}

languagestring_t * languageAddString(language_t *lang, char *key, char *text) {
  languagestring_t *string;

  string = lang->strings + lang->stringCount;
  string->key = key;
  string->text = text;

  lang->stringCount++;

  return string;
}

languagestring_t * languageGetStringByKey(language_t *language, char *key) {
  int32_t i;
  languagestring_t *string;

  for(i = 0; i < language->stringCount; i++) {
    string = language->strings + i;
    if(strcmp(string->key, key) != 0) continue;
    return string;
  }

  return NULL;
}

char * languageGetText(language_t *language, languagestring_t *string) {
  // TODO: Buffer this from somewhere.
  return string->text;
}

int32_t languageGetTextWithVariables(
  language_t *language, languagestring_t *string,
  stringhandlebarvariable_t *variables, int32_t variableCount,
  char *buffer
) {
  char *source;
  source = languageGetText(language, string);
  if(source == NULL) return 0;
  return stringHandlebarsBuffer(source, variables, variableCount, buffer);
}